/*
 * invcep.h
 *
 * Convert from cepstral coefficients back to a spectral representation.
 * For back-converting recognized frames to a spectral approximation.
 *
 * 1997jul29 dpwe@icsi.berkeley.edu
 * $Header: /n/yam/da/dpwe/projects/rasta/irasta/RCS/invcep.h,v 1.2 1997/11/05 02:27:11 dpwe Exp $
 */

int _cep2spec(float *incep, int ceplen, float *outspec, int specpts, 
	      double lift);
    /* Invert a cepstrum into a (linear) spectrum (without fvecs!) */
struct fvec *cep2spec(struct fvec *incep, int nfpts, double lift);
    /* Invert a cepstrum into a (linear) spectrum */
struct fvec *tolog(struct fvec *vec);
    /* take the log of an fvec */
struct fvec *toexp(struct fvec *vec);
    /* inverse of tolog() */
struct fvec *spec2cep(struct fvec *spec, int ncpts, double lift);
    /* Construct a cepstrum directly from a spectrum */
struct fvec *inv_postaud(const struct param *pptr, struct fvec *input);
    /* invert the post-audspec compression and weighting */
int _inv_postaud(float *input, float *output, int len, double srate);
    /* invert the post-audspec compression and weighting, no fvecs */

void lpc_to_spec(struct fvec* lpcptr, struct fvec* specptr );
    /* convert lpc coefficients directly to a spectrum */

struct fvec *spec2lpc(const struct param *pptr, struct fvec *in);
    /* Find an LPC fit to a spectrum */
struct fvec *lpc2cep(const struct param *pptr, struct fvec *lpcptr);
    /* Convert the LPC params to cepstra */
struct fvec *lpc2spec(const struct param *pptr, struct fvec *lpcptr);
    /* Convert the LPC params to a spectrum */

/* Covers to allow otcl access to inner rasta fns */
float my_auto_to_lpc(const struct param *pptr, struct fvec *autoptr, 
		     struct fvec *lpcptr);
/* do Levinson/Durbin recursion to get LPC coefs from autocorrelation vec */
